module Enumerable

    def sum
      self.inject(0){|accum, i| accum + i }
    end

    def mean
      self.sum/self.length.to_f
    end

    def median
      return 0 if self.size == 0
      if self.size==1
      	self[0]
      else
        sorted = self.sort
        mid = (sorted.length - 1) / 2.0
        (sorted[mid.floor] + sorted[mid.ceil]) / 2.0
      end
    end

    def sample_variance
      m = self.mean
      sum = self.inject(0){|accum, i| accum +(i-m)**2 }
      sum/(self.length - 1).to_f
    end

    def standard_deviation
      return Math.sqrt(self.sample_variance)
    end

end 


lines = File.read("repetition.csv").split("\n")

hash_per_year = Hash.new
hash_per_genre = Hash.new

lines.each do |line|
	data = line.split(",")
	file = data[0]
	value = data[-1].to_f

	file = file.gsub("/media/01e2acb2-1610-40c2-8df2-6ddb600bd9df/public/mp3/","")
	if file =~ /(.*)\/.*\/.*\((\d\d\d\d)\).*/
	  year = $2.to_i
	  genre = $1

	  hash_per_year[year] = Array.new unless hash_per_year.has_key? year
	  hash_per_year[year] << value

	  hash_per_genre[genre] = Array.new unless hash_per_genre.has_key? genre
	  hash_per_genre[genre] << value
	end
end

puts "year,mean, standard deviation, sample size, median"
hash_per_year.keys.sort.each do |year|
	puts "#{year}, #{hash_per_year[year].mean},#{hash_per_year[year].standard_deviation},#{hash_per_year[year].size},#{hash_per_year[year].median}"
end

hash_per_genre.keys.sort.each do |genre|
	puts "#{genre}, #{hash_per_genre[genre].mean},#{hash_per_genre[genre].standard_deviation},#{hash_per_genre[genre].size},#{hash_per_genre[genre].median}"
end